The Distributed File System (Dfs)

This topic describes the Distributed file system (Dfs) and how to administer it.

  • Before creating a distributed file system, see Checklist: Creating a distributed file system
  • Before managing a distributed file system, see Checklist: Managing a distributed file system
  • For recommendations on implementing Dfs, see Best practices
  • For help with specific tasks, see How to.
  • For general background information, see Concepts.
  • For problem-solving instructions, see Troubleshooting.


Checklist: Creating a distributed file system

Step | Reference
Review Distributed file system concepts | Concepts
Create a Dfs root for a distributed file system | Create a Dfs root
Add a root share | Add a root share
Add a Dfs link to a distributed file system | Add a Dfs link
Assign Dfs shared folders to a Dfs link | Add a Dfs shared folder
Configure replication for Dfs shared folders | Set replication policy


Checklist: Managing a distributed file system

Step | Reference
Review distributed file system concepts | Concepts
Display a Dfs root on the Dfs console | Display a Dfs root
Check the status of a Dfs shared folder | Check Dfs shared folder status
Remove the display of a Dfs root from the Dfs console | Remove the display of a Dfs root
Delete a Dfs root from a distributed file system | Delete a Dfs root


Best practices

  • Consider the following when installing and configuring the Distributed file system (Dfs).

    • Because automatic replication is only available on the NTFS file system, do not install Dfs on a FAT file system.

    When setting up your Dfs topology, add all Dfs links and Dfs shared folders for the first Dfs root before creating other Dfs roots.

  • Set the replication policy.

    • To maintain a balanced load on your server, you should consider the schedule of synchronization. This requires that you understand the following:

    • The topology between the participating servers.
    • How network performance may be impacted, based on available bandwidth.
    • The quantity of replication traffic likely to occur. Connections are optimized for DNS-based connection requests: A Dfs link automatically selects the nearest Dfs shared folder, based on the site topology information. However, the members of a set of Dfs shared folders must still be synchronized.
    • Replication schedules for the distributed file system, as well as the replication schedules for any other distributed file systems in the same site.
  • Perform daily administration as follows:

    • After you have created a Dfs console for the Dfs roots that you administer, save the console file for future use.

    For Dfs shared folders in which the content in the shared folders frequently changes, use a shorter cache time-out period to ensure that clients refresh the data. For shared folders in which the content in the shares seldom changes, you can extended the cache time-out period.

    Periodically, perform status check on common Dfs shared folders to ensure that the shared folders are still valid.

  • Consider the needs of your users

    • Users should be sure that you are aware of the shared folders they commonly use. If the shared folders do not already exist in a distributed file system, they should request that the shared folders be added to a Dfs root.


How to ...

  • Create a Dfs root
  • Add a Dfs root share
  • Delete a Dfs root share
  • Display a Dfs root
  • Add a Dfs link
  • Add a Dfs shared folder
  • Set replication policy
  • Check status of a Dfs shared folder
  • Remove the display of a Dfs root
  • Delete a Dfs root


Create a Dfs root

To create a Dfs root

  1. Open Dfs.
  2. On the Action menu, click New Dfs Root, then click Next.
  3. Click the type of Dfs root to create, either domain-based or stand-alone, then click Next.
  4. If you are creating a domain-based Dfs root, click the name of the domain where you want to create the root, then click Next.
  5. Enter the name of the host computer for the Dfs root or click a name from the list of available servers, then click Next.
  6. Click an existing shared folder or specify the path and name of a new shared folder to create, then click Next.
  7. Accept the default name for the Dfs root or specify a new name, then click Next.
  8. Click Finish to create the new Dfs root.

Notes

  • To open Dfs, click Start, point to Programs, point to Administrative Tools, and then click Distributed File System.
  • You must restart the computer to enable use of the new Dfs root.
  • Any member server or domain controller can host a Dfs root.
  • Currently, a host server is limited to one Dfs root. Although the Dfs root may be located in a FAT partition, NTFS offers considerable security advantages.

Related Topics


Add a Dfs root share

To add a Dfs root share

  1. Open Dfs.
  2. On the Action menu, click New Root Share.
  3. Enter the name of the host computer for the root share or click a name from the list of available servers, then click Next.
  4. Click an existing shared folder or specify the path and name of a new shared folder to create, then click Next.
  5. Accept the default name for the root share or specify a new name, then click Next.
  6. Click Finish to create the new root share.

Note

  • To open Dfs, click Start, point to Programs, point to Administrative Tools, then click Distributed File System.


Delete a Dfs root share

To delete a Dfs root share

  1. Open Dfs.
  2. In the console tree, right-click the Dfs root share.
  3. Click Delete Dfs Root Share.
  4. Enter the name of the Dfs root share to be deleted.

Note

  • To open Dfs, click Start, point to Programs, point to Administrative Tools, then click Distributed File System.


Display a Dfs root

To display a Dfs root

  1. Open Dfs.
  2. On the Action menu, click Display an Existing Dfs Root.
  3. In the Dfs root or host server field, type in the UNC name for an existing Dfs root, or expand the list of trusted domains and click the Dfs root, then click OK.

Note

  • To open Dfs, click Start, point to Programs, point to Administrative Tools, and then click Distributed File System.
  • To specify the Dfs root, you can type either \\My Computer\DfsRoot, or \\MyComputer\DfsFolder, where DfsRoot is the name you assigned to the Dfs root and DfsFolder is the name of the referenced shared folder.


Add a Dfs link

To add a Dfs link

  1. Open Dfs.
  2. In the console tree, right-click the Dfs root.
  3. Click New Dfs Link.
  4. Type a name and path for the new Dfs link or click Browse to select from the list of available shared folders.
  5. (Optional) Enter a comment to further identify or describe the Dfs link.
  6. Type the duration for which a reference to this Dfs link will be cached on a Dfs client, then click OK.

Note

  • To open Dfs, click Start, point to Programs, point to Administrative Tools, and then click Distributed File System.
  • When the cached period elapses, the Dfs client must access the root share to update the shared folder information. Entering a lower value increases associated network traffic. A higher value reduces associate network traffic at the possible expense of accurate share information.

Related Topics


Add a Dfs shared folder

To add a Dfs shared folder

  1. Open Dfs.
  2. In the console tree, right-click the Dfs link to which you want to assign a shared folder.
  3. Click New Dfs Shared Folder.
  4. Under Send the user to this shared folder, enter the name of a shared folder, or click Browse to select from the list of available shared folders.
  5. If the partition is an NTFS partition, choose one of the following:
    To | Do this
    Have the files that are located in the DFS root or DFS link that you selected automatically replicate as changes occur to the source file | Select the Join Replication check box
    Have the source file remain unchanged | Select the No Replication check box
  6. Copy the files to be replicated from the selected Dfs Root or Dfs link to the Dfs shared folder.

Note

  • To open Dfs, click Start, point to Programs, point to Administrative Tools, and then click Distributed File System.
  • This procedure for adding a Dfs shared folder should not be used for adding the first shared folder. The first shared folder is added when you create the Dfs link.
  • Join Replication requires that the host server for the Dfs root or Dfs link be a member of a domain.
  • Automatic replication is not available for stand-alone distributed file systems.

Related Topics


Set replication policy

To set replication policy

  1. Open Dfs.
  2. Right-click on a Dfs root or Dfs link and click Replication Policy.
  3. In the list of shared folders, click a Dfs shared folder that you want to use as the master folder for replication.
  4. Click each shared folder in the list and click either Enable or Disable, then click OK.

Notes

  • To open Dfs, click Start, point to Programs, point to Administrative Tools, then click Distributed File System.
  • By default, the first Dfs folder that you create becomes the master folder for replication. If you want to change this default, use the Initial Master button.
  • Once you have set a master for replication, the Initial Master button no longer appears when you subsequently display this window. This is because you only set a master once, to initiate replication; from then on, the Dfs shared folders replicate to one another whenever data in one of the Dfs shared folders changes.

Related Topics


Check status of a Dfs shared folder

To check status of a Dfs shared folder

  1. Open Dfs.
  2. In the Dfs console, right-click the Dfs root or Dfs link whose replication status you want to check, then click Check Status.

Notes

  • To open Dfs, click Start, point to Programs, point to Administrative Tools, and then click Distributed File System.

Related Topics


Remove the display of a Dfs root

To remove the display of a Dfs root

  1. Open Dfs.
  2. In the console tree, right-click the Dfs root node.
  3. Click Remove Display of Dfs Root, then click Yes.

Note

  • To open Dfs, click Start, point to Programs, point to Administrative Tools, and then click Distributed File System.
  • The Dfs root is removed from the console. It is not removed from the host computer. User access to the Dfs root is not affected by this procedure.


Delete a Dfs root

To delete a Dfs root

  1. Open Dfs.
  2. In the Dfs console, right-click the Dfs root node that you want to delete.
  3. Click Delete Dfs Root, then click Yes.

Important

  • This procedure removes the Dfs root from the console and from the host computer. This is not a recoverable operation. Any Dfs shared folders assigned to this root are removed, as well as all shared folder assignments.

Note

  • To open Dfs, click Start, point to Programs, point to Administrative Tools, and then click Distributed File System.


Concepts

This section covers:

  • Distributed file system overview
  • Understanding the Distributed File System (Dfs)
  • Using the Distributed File System (Dfs)


Distributed file system overview

The Distributed file system (Dfs) allows system administrators to make it easier for users to access and manage files that are physically distributed across a network. With Dfs, you can make files distributed across multiple servers appear to users as if they reside in one place on the network. Users no longer need to know and specify the actual physical location of files in order to access them.

For example, if you have marketing material scattered across multiple servers in a domain, you can use Dfs to make it appear as though all of the material resides on a single server. This eliminates the need for users to go to multiple locations on the network to find the information they need.

Reasons for using Dfs

You should consider implementing Dfs if:

  • Users who access shared folders are distributed across a site or sites.
  • Most users require access to multiple shared folders.
  • Server load balancing could be improved by redistributing shared folders.
  • Users require uninterrupted access to shared folders.
  • Your organization has Web sites for either internal or external use.

Dfs types

Using the Dfs console, you can implement a distributed file system in either of two ways--either as a stand-alone distributed file system, or as a domain-based distributed file system.

Dfs architecture

In addition to the server-based Dfs component of Windows 2000, there is a client-based Dfs component. The Dfs client caches a referral to a Dfs root or a Dfs link for a specific length of time, defined by the administrator.

A computer running the Dfs client must be a member of the domain for the Dfs root.

The Dfs client component runs on a number of different Windows platforms. For information on Dfs client versions and their associated platforms, see Platform compatibility.

For more information, see Understanding the Distributed File System (Dfs) and Using the Distributed File System (Dfs).


Understanding the Distributed file system (Dfs)

This section covers:

  • Distributed file system features
  • Distributed file system topology
  • Distributed file system and security
  • Platform compatibility


Distributed file system features

The Distributed file system (Dfs) provides several important features, described in the following sections.

Easy access to files

A distributed file system makes it easier for users to access files. Users need only go to one location on the network to access files, even though the files may be physically spread across multiple servers.

Also, when you change the physical location of a shared folder, user access to the folder is not impacted. They still access the folder in the same way as before, because the location of the file looks the same.

Users no longer need multiple drive mappings to access their files.

Finally, scheduled file server maintenance, software upgrades and other tasks that normally require taking the server offline can be accomplished without disrupting user access. This is particularly useful for Web servers. By selecting the root for the Web site as a Dfs root, you can move resources within the distributed file system without breaking any HTML links.

Availability

Domain-based Dfs ensures that users retain access to their files, in two ways:

First, Windows 2000 automatically publishes the Dfs topology to Active Directory. This ensures that the Dfs topology is always visible to users on all servers in the domain.

Second, as an administrator, you can replicate your Dfs roots and your Dfs shared folders. Replication means that you can duplicate Dfs roots and Dfs shared folders on multiple servers in the domain. In this way, users can still access their files, even if one of the physical servers on which those files reside becomes unavailable.

Server load balancing

A Dfs root can support multiple Dfs shared folders that are physically distributed across a network. This is useful, for example, if you have a file that you know will be accessed heavily by your users. Rather than all users physically accessing this file on a single server, and thus taxing the server, Dfs ensures that user access to the file is distributed to multiple servers. To users, however, the file resides in one location on the network.


Distributed file system topology

A Distributed file system (Dfs) topology consists of a Dfs root, one or more Dfs links, and one or more Dfs shared folders, or replicas, to which each Dfs link points.

The domain server on which a Dfs root resides is known as a host server. You can replicate a Dfs root by creating root shares on other servers in the domain. This provides file availability when the host server becomes unavailable.

To users, a Dfs topology provides unified and transparent access to the network resources they need. To system administrators, a Dfs topology is a single DNS namespace: With domain-based Dfs, the DNS names for the Dfs root shares resolve to the host servers for the Dfs root.

Because the host server for a domain-based distributed file system is a member server within a domain, the Dfs topology is automatically published to Active Directory by default, thus providing synchronization of Dfs topologies across host servers. This, in turn, provides fault tolerance for the Dfs root and supports optional replication of Dfs shared folders.

You can expand a Dfs topology by adding a Dfs link to the Dfs root. The only constraint on the number of hierarchical levels in a Dfs topology is imposed by the Windows 2000 limit of 260 characters for any file path. A new Dfs link can refer to a shared folder with or subfolders, or to an entire Windows 2000 volume. If you have adequate permissions, you can also access any local subfolders that exist in or are added to a Dfs shared folder.


Distributed file system and security

Aside from creating the necessary Administrator permissions, the Distributed file system (Dfs) service does not implement any additional security measures, beyond what the Windows 2000 system provides. The permissions assigned to a Dfs root or Dfs link determine who can add a new Dfs link.

Permissions to a shared folder are not related to the Dfs topology. For example, suppose there is a Dfs link named MarketingDocs and you have appropriate permissions to accesss a particular Dfs shared folder to which MarketingDocs points. In this case, you can then access all other Dfs shared folders in the set of Dfs shared folders, regardless of whether or not you have permissions to access those other shared folders. However, having permission to access these shared folders does determine whether or not you have access to any of the information within the shared folders. Such access is determined by standard Windows 2000 security controls.

In summary, security is enforced by the underlying file system when a user tries to access a Dfs shared folder and its contents. Thus, a FAT volume provides share-level security on files, while an NTFS volume provides full Windows 2000 security.


Platform compatibility

Windows 2000 supports Dfs shared folders, or replicas, on the following platforms.

Platform | Host Dfs Client | Host Dfs Root
DOS, Windows 3.x, Windows for Workgroups, and NetWare servers | No | No
Windows 95 | Yes, download client for Dfs 4.x and 5.0 | No
Windows 98 | Yes, Dfs 4.x and 5.0 (stand-alone) client included; download client for Dfs 5.0 (domain-based) | No
Windows NT 4.0 and Service Pack 3 | Yes, Dfs 4.x and 5.0 (stand-alone) client included | Yes, stand-alone server only
Windows 2000 | Dfs 5.0 client included | Yes, stand-alone and domain-based server or domain controller

Note

  • To support synchronization of Dfs shared folders, the referenced resource for a Dfs shared folder must be located on a Windows 2000 NTFS partition.


Using the Distributed File System (Dfs)

This section covers:

  • Creating a Dfs root
  • Adding a root share
  • Adding a Dfs link
  • Adding a Dfs shared folder
  • Configuring replication
  • Checking Dfs shared folder status


Creating a Dfs root

You can create a Dfs root on Windows 2000 FAT or NTFS partitions. However, the FAT file system does not offer the security advantages of NTFS. When creating a Dfs root, you have the option of establishing either a stand-alone Dfs root or a domain-based root.

A stand-alone Dfs root:

  • Does not use Active Directory.
  • Cannot have root-level Dfs shared folders.
  • Has a limited hierarchy. A standard Dfs root can have only a single level of Dfs links.

A domain-based Dfs root:

  • Must be hosted on a domain member server.
  • Has its Dfs topology automatically published to Active Directory.
  • Can have root-level Dfs shared folders.
  • Does not have a limited hierarchy. A domain-based Dfs root can have multiple levels of Dfs links.

Using the Dfs console, you specify a shared folder to assign as the Dfs root. In addition to accessing this shared folder, users can access any subfolders of this shared folder.

For more information, see Create a Dfs root.


Adding a root share

Replicating a Dfs root to another server in the domain ensures that if the host server becomes unavailable for any reason, the distributed file system associated with that Dfs root is still available to domain users.

To replicate a Dfs root, you start the Distributed file system console and select New Root Share from the Dfs Root menu. This invokes the Root Share wizard.

Note

  • From the Dfs console, you can also delete a root share.


Adding a Dfs link

You can add a Dfs link at the root of the Dfs topology. If the target folder of the Dfs link is not a Windows 2000 folder, the target folder cannot have subfolders.

Currently, the maximum number of Dfs links that you can assign to a Dfs root is 1000.

Each shared folder that you add has an associated client-caching duration assigned. The caching duration determines how long the shared folder information is cached on the client. When the caching duration elapses, the Dfs client must access the Dfs host server to update the referral information. You can adjust the caching duration to best balance the factors of client use and network traffic associated with a shared folder.

For more information, see Add a Dfs link.


Adding a Dfs shared folder

For each Dfs link, you can create a set of Dfs shared folders to which the Dfs link points. Within a set of Dfs shared folders, you add the first folder to the set when you create the Dfs link, using the Distributed file system console. Subsequent Dfs folders are added using the console's New Shared Folder dialog box.

The maximum number of Dfs shared folders allowed in a set of shared folders is 32.

Within a set of Dfs shared folders, you can choose which folders will participate in replication. If you add Dfs shared folders for domain-based Dfs roots, you also need to do the following:

  • Set the replication policy among the shared folders.
  • Check the replication status.

For information on setting replication policy, see Configuring replication.

For information on checking replicaton status, see Checking replication status.


Configuring replication

You can ensure that the content of folders is always available to users by replicating that content to other root shares or Dfs shared folders in the domain.

You can replicate both Dfs roots and Dfs shared folders. Replication copies the content of one Dfs root to another root share, or from one Dfs shared folder to another Dfs shared folder.

Replicating a Dfs root

Replicating a Dfs root to another server in the domain ensures that if the host server becomes unavailable for any reason, the distributed file system associated with that Dfs root is still available to domain users.

To replicate a Dfs root, you start the Distributed file system console and select New Root Share from the Dfs Root menu. This invokes the Root Share wizard.

Replicating a Dfs shared folder

When replicating a Dfs shared folder, Dfs stores a duplicate copy of the contents of the original shared folder into another shared folder.

Replicating a Dfs shared folder is a two-step process: First, you add the Dfs shared folder to a Dfs link, specifying that the folder will participate in replication. Then, you set the replication policy for the set of Dfs shared folders associated with that link.

Replication of Dfs shared folders can be done either manually or automatically, as described in the following sections.

Automatic replication

For domain-based Dfs, you can enable Dfs to automatically replicate the contents of a Dfs shared folder to other folders in the set of Dfs shared folders. This keeps the content of the Dfs shared folders synchronized as changes to one or more of the Dfs shared folders occurs.

You enable automatic replication by using the Replication Policy window of the Distributed file system console. Although invisible to users and administrators, Dfs uses the File Replication Service (FRS) to perform this function. Within a set of Dfs folders, FRS manages updates across any folders that are targeted for replication. By default, FRS synchronizes the contents of the Dfs shared folders at 15-minute intervals.

When you set replication policy, you select one of your Dfs shared folders as the initial master, which then replicates its contents to the other Dfs shared folders in the set of Dfs shared folders.

Manual replication

For domain-based Dfs, if you do not enable FRS management of Dfs shared folders, you must maintain the same content in all of the Dfs shared folders manually.

For stand-alone Dfs, only manual replication is available.

Notes

  • Automatic replication can only be used for files stored on NTFS volumes on Windows 2000 servers. Other types of files, such as FAT files, must be replicated manually.
  • Within a set of Dfs shared folders, you should not mix automatic and manual replication. Using either automatic replication or manual replication exclusively within a set of Dfs shared folders ensures that the contents of the Dfs shared folders remains synchronized.


Checking Dfs shared folder status

You can check whether the Dfs shared folders, or replicas, that you have assigned are being referenced properly by Dfs. The status check indicates one of the following conditions:

  • The Dfs shared folder was found and is accessible.
  • The Dfs shared folder was not found.


Troubleshooting

What problem are you having?

Can't access a Dfs shared folder.

Cause: The server to which you are connected is unavailable.

Solution: Use Windows Explorer to display the properties of the shared folder and determine the physical resource to which you are connected. Verify that the resource can be contacted and that nothing has been set to block access.

Solution: Use the Distributed File System console to check the status of your Dfs shared folders.